insert into `ombutel`.`xepm_hosts` (`hostname`,`label`,`sip_port`,`iax2_port`,`http_port`,`https_port`,`default`)
select * from (select 'example.com', 'Default', 5060, 4569, 80, 443, 'yes') t
where not exists (select null from `ombutel`.`xepm_hosts` where `default` = 'yes');

select `host_id` into @host from `ombutel`.`xepm_hosts` where `default` = 'yes';
select (unix_timestamp(utc_timestamp()) - unix_timestamp(now())) into @offset;

insert into `ombutel`.`xepm_templates` (`model_id`,`host_id`,`timezone_id`,`configuration_type_id`,`name`,`admin_password`)
select v.* from (
	select
		ct.`model_id`,
		@host,
		tz.`timezone_id`,
		min(ct.`configuration_type_id`),
		concat(b.name,' ', m.name,' - Default') as `name`,
		'admin'
	from `ombutel`.`xepm_configuration_types` ct
	left join `ombutel`.`xepm_models` m using (`model_id`)
	left join `ombutel`.`xepm_brands` b using (`brand_id`)
	left join (
		select `timezone_id`, `brand_id`, min(abs(`offset` - @offset))
		from `ombutel`.`xepm_timezones` t
		group by `brand_id`
	) tz on (tz.`brand_id` = b.`brand_id`)
	group by ct.`model_id`
) v
left join `ombutel`.`xepm_templates` t on (t.`name` = v.`name`)
where t.`template_id` is null;
