-- add ident column to brands

alter table `ombutel`.`xepm_brands`
	add column `ident` varchar(255) not null default '' after `brand_id`;

update `ombutel`.`xepm_brands`
set `ident` = replace(replace(replace(lower(`name`),' ',''),'-',''),'/','');

alter table `ombutel`.`xepm_brands`
	modify column `ident` varchar(255) not null,
	drop index `name`,
	add unique(`ident`);

-- add ident column to models

alter table `ombutel`.`xepm_models`
	add column `ident` varchar(255) not null default '' after `dss_buttons`;

update `ombutel`.`xepm_models`
set `ident` = replace(replace(replace(lower(`name`),' ',''),'-',''),'/','');

alter table `ombutel`.`xepm_models`
	modify column `ident` varchar(255) not null,
	drop foreign key `xepm_models_ibfk_1`,
	drop index `brand_id`,
	add unique(`brand_id`, `ident`);

alter table `ombutel`.`xepm_models`
	add constraint `xepm_models_ibfk_1` foreign key (`brand_id`)
	references `ombutel`.`xepm_brands` (`brand_id`) on delete cascade;

-- add ident column to modules

alter table `ombutel`.`xepm_modules`
	add column `ident` varchar(255) not null default '' after `button_count`;

update `ombutel`.`xepm_modules`
set `ident` = replace(replace(lower(`name`), ' ',''),'.','');

update `ombutel`.`xepm_modules` m
left join (
	select 'expansionmodulev2' as `old`, 'v2' as `new`
	union all select 'vvxexpmodule', 'basic'
	union all select 'vvxcolorexpmodule', 'color'
	union all select 'soundpointipcolorexpmodule', 'color'
	union all select 'soundpointipbacklitexpmodule', 'backlit'
	union all select 'maxwellexpansion', 'basic'
) i on (i.`old` = m.`ident`)
set m.`ident` = i.`new`
where i.`new` is not null;
