-- Add missing settings for Polycom basic module support

insert into `ombutel`.`xepm_settings` (`parent_id`, `configuration_type_id`, `setting_type_id`, `name`, `default`)
select p.`setting_id`, ct.`configuration_type_id`, st.`setting_type_id`, i.`name`, ''
from (
	select 'polycom' as `brand`, 'vvx400' as `model`, 'generic' as `config`, 'attendant.resourceList.131.address' as `name`
	union all select 'polycom', 'vvx400', 'generic', 'attendant.resourceList.131.label'
	union all select 'polycom', 'vvx400', 'generic', 'attendant.resourceList.131.type'
	union all select 'polycom', 'vvx400', 'generic', 'attendant.resourceList.132.address'
	union all select 'polycom', 'vvx400', 'generic', 'attendant.resourceList.132.label'
	union all select 'polycom', 'vvx400', 'generic', 'attendant.resourceList.132.type'
	union all select 'polycom', 'vvx410', 'generic', 'attendant.resourceList.131.address'
	union all select 'polycom', 'vvx410', 'generic', 'attendant.resourceList.131.label'
	union all select 'polycom', 'vvx410', 'generic', 'attendant.resourceList.131.type'
	union all select 'polycom', 'vvx410', 'generic', 'attendant.resourceList.132.address'
	union all select 'polycom', 'vvx410', 'generic', 'attendant.resourceList.132.label'
	union all select 'polycom', 'vvx410', 'generic', 'attendant.resourceList.132.type'
	union all select 'polycom', 'vvx500', 'generic', 'attendant.resourceList.131.address'
	union all select 'polycom', 'vvx500', 'generic', 'attendant.resourceList.131.label'
	union all select 'polycom', 'vvx500', 'generic', 'attendant.resourceList.131.type'
	union all select 'polycom', 'vvx500', 'generic', 'attendant.resourceList.132.address'
	union all select 'polycom', 'vvx500', 'generic', 'attendant.resourceList.132.label'
	union all select 'polycom', 'vvx500', 'generic', 'attendant.resourceList.132.type'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.131.address'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.131.label'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.131.type'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.132.address'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.132.label'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.132.type'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.133.address'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.133.label'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.133.type'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.134.address'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.134.label'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.134.type'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.135.address'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.135.label'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.135.type'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.136.address'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.136.label'
	union all select 'polycom', 'vvx600', 'generic', 'attendant.resourceList.136.type'
) i
left join `ombutel`.`xepm_brands` b on (b.`ident` = i.`brand`)
left join `ombutel`.`xepm_models` m on (m.`brand_id` = b.`brand_id` and m.`ident` = i.`model`)
left join `ombutel`.`xepm_configuration_types` ct on (ct.`model_id` = m.`model_id` and ct.`ident` = i.`config`)
left join `ombutel`.`xepm_settings` p on (p.`configuration_type_id` = ct.`configuration_type_id`)
left join `ombutel`.`xepm_setting_types` st on (st.`ident` = 'exp_buttons')
left join `ombutel`.`xepm_settings` s on (
	s.`parent_id` = p.`setting_id`
	and s.`configuration_type_id` = ct.`configuration_type_id`
	and s.`name` = i.`name`)
where p.`parent_id` is null and p.`name` = 'attendant'
and s.`setting_id` is null
and p.`setting_id` is not null
and ct.`configuration_type_id` is not null
and st.`setting_type_id` is not null;
