use `ombutel`;

CREATE TABLE `ombu_teams_profiles` (
   `profile_id` int(10) unsigned NOT NULL,
   `peertype` enum('friend','peer','user') COLLATE utf8_unicode_ci NOT NULL, -- Type
   `qualify` int(10) unsigned NOT NULL,
   `qualifyfreq` int(10) unsigned NOT NULL,
   `transport` enum('udp','tcp','tls') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'udp',
   `icesupport` enum('yes','no') COLLATE utf8_unicode_ci NOT NULL,
   `avpf` enum('yes','no') COLLATE utf8_unicode_ci NOT NULL,
   `directmedia` enum('yes','no','nonat','update') COLLATE utf8_unicode_ci NOT NULL,
   `codecs` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
   `deny` varchar(255) COLLATE utf8_unicode_ci DEFAULT '0.0.0.0/0',
   `permit` varchar(255) COLLATE utf8_unicode_ci DEFAULT '0.0.0.0/0',
   `dtmfmode` enum('rfc2833','info','shortinfo','inband','auto') COLLATE utf8_unicode_ci DEFAULT 'rfc2833',
   `nat` enum('no','force_rport','comedia','auto_force_rport','auto_comedia','force_rport,comedia') COLLATE utf8_unicode_ci NOT NULL,
   `videosupport` enum('always','yes','no') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'no',
   `maxcallbitrate` int(10) unsigned NOT NULL DEFAULT '384',
   `preferred_codec_only` enum('no','yes') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'no',
   `autoframing` enum('no','yes') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'no',
   `external_hostname` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
   `remote_outbound_proxy` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
   `country` int(10) unsigned NOT NULL DEFAULT '90',
   `outside_line_prefix` varchar(10) COLLATE utf8_unicode_ci DEFAULT NULL,
   `teams_service_id` varchar(15) COLLATE utf8_unicode_ci DEFAULT NULL,
   PRIMARY KEY (`profile_id`),
   CONSTRAINT `ombu_teams_profiles_ibfk_1` FOREIGN KEY (`profile_id`) REFERENCES `ombu_device_profiles` (`profile_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

insert into `ombu_device_profiles` (`technology`, `name`, `description`, `default`) values
    ('teams', 'Default MS Teams Connect Profile', 'Default MS Teams Connect Profile', 'yes');
select `profile_id` from `ombu_device_profiles` where `name` = 'Default MS Teams Connect Profile' into @teams_profile_id;

insert ignore into `ombu_teams_profiles` (`profile_id`, `peertype`, `qualify`, `qualifyfreq`, `transport`, `icesupport`, `avpf`, `directmedia`, `codecs`, `deny`, `permit`, `dtmfmode`, `nat`) values
(@teams_profile_id, 'friend', 2000, 60, 'udp', 'no', 'no', 'nonat', 'g729', '0.0.0.0/0', '0.0.0.0/0', 'rfc2833', 'no');

