use `ombutel`; -- workaround MySQL delete bug

-- remove old timezones

delete mtz
from `ombutel`.`xepm_brands` b
left join `ombutel`.`xepm_models` m on (m.`brand_id` = b.`brand_id`)
left join `ombutel`.`xepm_model_timezones` mtz on (mtz.`model_id` = m.`model_id`)
where b.`ident` = 'fanvil' and m.`ident` = 'x5s';

-- add correct timezones

create temporary table `ombutel`.`x5s_timezones` (
	`offset` int not null,
	`name` varchar(255) not null,
	`value` varchar(255) not null
);

insert into `ombutel`.`x5s_timezones` (`offset`, `name`,`value`) values
	(-39600,'American Samoa','-44,UTC-11'),
	(-36000,'United States,United States','-40,UTC-10'),
	(-34200,'French Polynesia','-38,UTC-9:30'),
	(-32400,'United States','-36,UTC-9'),
	(-28800,'Canada,Mexico,United States','-32,UTC-8'),
	(-25200,'Canada,Mexico,United States,United States-MST','-28,UTC-7'),
	(-21600,'Canada,Chile,Mexico,United States','-24,UTC-6'),
	(-18000,'Bahamas,Canada,Cuba,United States','-20,UTC-5'),
	(-16200,'Venezuela','-18,UTC-4:30'),
	(-14400,'Canada,Chile,Paraguay,United Kingdom,United Kingdom,Trinidad Tobago','-16,UTC-4'),
	(-12600,'Canada','-14,UTC-3:30'),
	(-10800,'Denmark-Greenland,Argentina,Brazil,Brazil','-12,UTC-3'),
	(-9000,'Newfoundland and Labrador','-10,UTC-2:30'),
	(-7200,'Brazil','-8,UTC-2'),
	(-3600,'Portugal','-4,UTC-1'),
	(0,'GMT,Greenland,Denmark-Faroe Islands,Ireland,Portugal,Spain-Canary Islands,United Kingdom,Morocco','0,UTC'),
	(3600,'Albania,Austria,Belgium,Caicos,Chad,Spain,Croatia,Czech Republic,Denmark,France,Germany,Hungary,Italy,Luxembourg,Macedonia,Netherlands,Namibia','4,UTC+1'),
	(7200,'Estonia,Finland,Gaza Strip,Greece,Israel,Jordan,Latvia,Lebanon,Moldova,Russia,Romania,Syria,Ukraine','8,UTC+2'),
	(10800,'East Africa Time,Iraq,Russia,Turkey,Riyadh,Kuwait','12,UTC+3'),
	(12600,'Tehran,Iran','14,UTC+3:30'),
	(14400,'Armenia,Azerbaijan,Georgia,Kazakhstan,Iraq,Russia,Abu Dhabi,Oman','16,UTC+4'),
	(16200,'Afghanistan','18,UTC+4:30'),
	(18000,'Kazakhstan,Kyrgyzstan,Pakistan,Russia','20,UTC+5'),
	(19800,'India','22,UTC+5:30'),
	(20700,'Nepal','23,UTC+5:45'),
	(21600,'Kazakhstan,Russia','24,UTC+6'),
	(23400,'Myanmar','26,UTC+6:30'),
	(25200,'Russia,Thailand','28,UTC+7'),
	(28800,'China,Singapore,Australia,Russia','32,UTC+8'),
	(31500,'Australia','35,UTC+8:45'),
	(32400,'Korea,Japan,Russia','36,UTC+9'),
	(34200,'Australia,Australia','38,UTC+9:30'),
	(36000,'Australia,Australia,Australia,Russia','40,UTC+10'),
	(37800,'Australia','42,UTC+10:30'),
	(39600,'New Caledonia,Russia','44,UTC+11'),
	(41400,'Norfolk Island','46,UTC+11:30'),
	(43200,'New Zealand,Russia','48,UTC+12'),
	(45900,'New Zealand','51,UTC+12:45'),
	(46800,'Tonga,Apia','52,UTC+13'),
	(48600,'Chatham Islands','54,UTC+13:30'),
	(50400,'Kiribati','56,UTC+14');

insert into `ombutel`.`xepm_timezones` (`offset`, `name`, `value`)
select x5s.`offset`, x5s.`name`, x5s.`value`
from `ombutel`.`x5s_timezones` x5s
left join `ombutel`.`xepm_timezones` tz on (tz.`offset` = x5s.`offset` and tz.`name` = x5s.`name` and tz.`value` = x5s.`value`)
where tz.`timezone_id` is null;

insert into `ombutel`.`xepm_model_timezones` (`model_id`, `timezone_id`)
select m.`model_id`, tz.`timezone_id`
from `ombutel`.`xepm_brands` b
join `ombutel`.`x5s_timezones` x5s
left join `ombutel`.`xepm_models` m on (m.`brand_id` = b.`brand_id`)
left join `ombutel`.`xepm_timezones` tz on (tz.`offset` = x5s.`offset` and tz.`name` = x5s.`name` and tz.`value` = x5s.`value`)
where b.`ident` = 'fanvil' and m.`ident` = 'x5s' and tz.`timezone_id` is not null;

-- fix template timezones

update `ombutel`.`xepm_brands` b
left join `ombutel`.`xepm_models` m on (m.`brand_id` = b.`brand_id`)
left join `ombutel`.`xepm_configuration_types` ct on (ct.`model_id` = m.`model_id`)
left join `ombutel`.`xepm_templates` t on (t.`configuration_type_id` = ct.`configuration_type_id`)
left join `ombutel`.`xepm_timezones` tz1 on (tz1.`timezone_id` = t.`timezone_id`)
left join `ombutel`.`xepm_timezones` tz2 on (tz2.`offset` = tz1.`offset`)
set t.`timezone_id` = tz2.`timezone_id`
where b.`ident` = 'fanvil' and m.`ident` = 'x5s' and tz1.`timezone_id` is not null;

-- fix model timezones

update `ombutel`.`xepm_brands` b
left join `ombutel`.`xepm_models` m on (m.`brand_id` = b.`brand_id`)
left join `ombutel`.`xepm_configuration_types` ct on (ct.`model_id` = m.`model_id`)
left join `ombutel`.`xepm_templates` t on (t.`configuration_type_id` = ct.`configuration_type_id`)
left join `ombutel`.`xepm_devices` d on (d.`template_id` = t.`template_id`)
left join `ombutel`.`xepm_timezones` tz1 on (tz1.`timezone_id` = d.`timezone_id`)
left join `ombutel`.`xepm_timezones` tz2 on (tz2.`offset` = tz1.`offset`)
set d.`timezone_id` = tz2.`timezone_id`
where b.`ident` = 'fanvil' and m.`ident` = 'x5s' and tz1.`timezone_id` is not null;
