$(function() {
	const servers = new ombu.datatable(
		$("#authenticationradius .radius-servers"),
		"authentication",
		"radius_servers",
		true
	);
	$("#authenticationradius .datatable").on("click", "td button:nth-of-type(1)", (event) => {
		var key = $(event.target).closest("tr").data("key");
		do_action(`/edit-radius-server/${key}`);
		return false;
	});
	$("#authenticationradius .datatable").on("click", "td button:nth-of-type(2)", (event) => {
		var key = $(event.target).closest("tr").data("key");
		do_action(`/delete-radius-server/${key}`);
		return false;
	});
	$("#authenticationradius").on("refresh_radius_servers", servers.update);
});

$("form#authentication_form").on("submit", () => {
	if ($("form#authentication_form").data("confirmed")) {
		return true;
	}
	const values = [
		$("form#authentication_form [name='first']").val(),
		$("form#authentication_form [name='second']").val(),
		$("form#authentication_form [name='third']").val(),
	];
	if (values.includes("local")) {
		return true;
	}
	BootstrapDialog.show({
		type: BootstrapDialog.TYPE_WARNING,
		title: ombu.i18n.authentication.please_confirm,
		message: ombu.i18n.authentication.confirm_no_local,
		closable: false,
		buttons: [{
			label: ombu.i18n.ombutel.confirm,
			cssClass: "btn-warning",
			action: (dialog) => {
				dialog.close();
				$("form#authentication_form").data("confirmed", true);
				$("form#authentication_form").trigger("submit");
			}
		}, {
			label: ombu.i18n.ombutel.cancel,
			cssClass: "btn-primary",
			action: (dialog) => {
				dialog.close();
			}
		}]
	});
	return false;
});
