var epm_device_dialog = {};

// Removes the module
epm_device_dialog.remove_module = function(event) {
	event.stopPropagation();
	var element = event.target;
	if(confirm("Are you sure you want to remove this module ?")) {
		var module_index = $(element).closest("li").index();
		$("ul#mapping_attached_modules li").eq(module_index).remove();
		$("div#mapping_modules div").eq(module_index).remove();
		epm_device_dialog.attached_modules = null;
		if(typeof epm_device_dialog.attached_modules != "undefined") {
			epm_device_dialog.attached_modules = parseInt($("ul#mapping_attached_modules li").length) - 1;
		}
		if (epm_device_dialog.visible_module == module_index) { epm_device_dialog.show_last_module(); }
		$('button#xepm_add_module').prop('disabled', false);
	}
};

// Add a module to device
epm_device_dialog.add_module = function(e) {
	epm_device_dialog.attached_modules = null;
	if(typeof epm_device_dialog.attached_modules != "undefined") {
		epm_device_dialog.attached_modules = parseInt($("ul#mapping_attached_modules li").length);
	}
	var max_modules = $('#epm_device_conf_exp_modules #mapping_max_modules').val();
	var device_id = $('#modal-epm-device_configure #data').val();
	if(max_modules !== 'undefined' && !isNaN(parseInt(max_modules)) &&
		parseInt(max_modules) > 0 && device_id !== 'undefined' &&
		!isNaN(parseInt(device_id) && parseInt(device_id) > 0)
	) {
		if (epm_device_dialog.attached_modules < parseInt(max_modules)) {
			var modules = $("select#mapping_module_id");
			var module_id = modules.val();
			if(parseInt(module_id) > 0) {
				$('button#xepm_add_module').prop('disabled', true);
				var module_name = modules.children(':selected').text();
				var attached_modules = $('input[name="mapping_attached_modules[]"]');
				var modules = [];
				$.each(attached_modules, function(index, module) {
					modules[index] = module.value; // get all atached modules
				});
				modules.push(module_id); // append the current module
				$.ajax({
					type: "POST",
					url: epm_device_dialog.url,
					dataType: 'json',
					data: {
						class: 'endpoint',
						method: 'add_module_for_device',
						modules: modules.join(","),
						device_id: device_id
					},
					success: function (data) {
						epm_device_dialog.populate_module_button_data(data.module_button_types, data.lines);
						if(data.exp_buttons != null) {
							$("<li/>", { text: module_name })
							.bind("click", function(event) { epm_device_dialog.show_module(event.target); })
							.append(
								$("<i/>", { class : "fa fa-close btn" })
								.bind("click", function(event) { epm_device_dialog.remove_module(event); }))
							.appendTo($("ul#mapping_attached_modules"));
							$("div#mapping_modules").append(
								$("<div>").css({'display' : 'block'}).addClass('mapping_attached_modules').append(
									$("<input>").attr({
										'type' : 'hidden',
										'name' : 'mapping_attached_modules[]',
										'value' : module_id
									}),
									epm_device_dialog.add_exp_table(data.exp_buttons, epm_device_dialog.attached_modules++)
								)
							);
							epm_device_dialog.show_last_module();
						}
						$('button#xepm_add_module').prop('disabled', false);
					}
				});
			}
		}
	} else {
		$('button#xepm_add_module').prop('disabled', false);
	}
};

// Add expansion table to device
epm_device_dialog.add_exp_table = function(exp_buttons, module_index) {
	var table = $("<table>").addClass('epm_device_conf_exp_buttons').append(
		$("<thead>").append(
			$("<tr>").append(
				$("<th>").addClass('center'),
				$("<th>").addClass('center').html('Label'),
				$("<th>").addClass('center').html('Type'),
				$("<th>").addClass('center').html('value'),
				$("<th>").addClass('center').html('Line')
			)
		),
		$("<tbody>")
	);
	var row = $("table.epm_device_conf_exp_table_hidden tbody").find('tr');
	$.each(exp_buttons, function(button_index, button) {
		var button_row = row.clone();
		button_row = epm_device_dialog.add_exp_buttons(button_row, module_index, button, button_index);
		$(button_row).appendTo(table);
	});
	return table;
};

// Add expansion buttons
epm_device_dialog.add_exp_buttons = function(row, module_index, button, button_index) {
	var td = $(row).find('td');
	var inputs = $(row).find('input');
	var selects = $(row).find('select');
	row.removeClass('exp_buttons_row');
	$(td[0]).text('Button ' + (parseInt(button_index) + 1));
	$(inputs[0]).val(button.label);   //label
	$(inputs[0]).attr('name', 'mapping_expansion_buttons[' + module_index + '][' + button_index + '][label]');
	$(inputs[1]).val(button.value);   //value
	$(inputs[1]).attr('name', 'mapping_expansion_buttons[' + module_index + '][' + button_index + '][value]');
	$(selects[0]).val(button.type);   //type
	$(selects[0]).attr('name', 'mapping_expansion_buttons[' + module_index + '][' + button_index + '][type]');
	$(selects[1]).val(button.line);   //line
	$(selects[1]).attr('name', 'mapping_expansion_buttons[' + module_index + '][' + button_index + '][line]');
	return row;
};

// Populate module button types and module button lines
epm_device_dialog.populate_module_button_data = function(types, lines) {
	var table = $("table.epm_device_conf_exp_table_hidden tbody");
	if(types != null) {
		var selects = $("table.epm_device_conf_exp_table_hidden tbody tr").find('select');
		$(selects).find('option').empty(); // Clean the options
		selects.eq(0).fill(types, function(type) {
			this.val(type.ident);
			this.text(type.name);
		}); // populate module button types
	}
	if(lines != null) {
		selects.eq(1).fill(lines, function(line) {
			this.val(line.ident);
			this.text(line.name);
		}); // populate module button lines
	}
};

// Show the last module
epm_device_dialog.show_last_module = function() {
	epm_device_dialog.show_indexed_module($("ul#mapping_attached_modules li").length - 1);
};

// Show the indexed module
epm_device_dialog.show_indexed_module = function(module_index) {
	if (module_index >= 0) {
		var tabs = $("ul#mapping_attached_modules li");
		var divs = $("div#mapping_modules div");
		tabs.removeClass("active");
		tabs.eq(module_index).addClass("active");
		divs.hide();
		divs.eq(module_index).show();
		epm_device_dialog.visible_module = module_index;
	} else {
		delete epm_device_dialog.visible_module;
	}
};

// Show settings for setting group
epm_device_dialog.change_settings = function(event) {
	var group_id = $(event.target).val();
	$("div.mapping_setting_group").hide();
	$("div[id='"+group_id+"']").show();
};

// Show the clicked module
epm_device_dialog.show_module = function(element) {
	epm_device_dialog.show_indexed_module($(element).index());
};

$("form#modal-epm-device_configure").submit(function() {
	$(this).ajaxSubmit({
		success: processServerResponse,
		dataType: "json",
		url: $(this).attr("action"),
		resetForm: false,
		error: processServerErrors,
	});
	return false;
});
