(function () {
	var in_dropdown = function(value, element) {
		for (var i in element.options) {
			if (element.options[i].value == value) {
				return true;
			}
		}
		return false;
	};
	$("#dahdi_spansgeneral select[name^='profile_bulk']").each(function () {
		$(this).change(function () {
			var value = $(this).val();
			if (value) {
				$("#dahdi_spansgeneral select[name='profiles[]']").each(function () {
					if (in_dropdown(value, this)) { $(this).val(value); }
				});
			}
		});
		var populate = function () {
			var technology = $("#dahdi_spansgeneral select[name='technology']").val();
			$("#dahdi_spansgeneral select[name^='profile_bulk']").each(function () {
				var element = $(this).empty();
				element.append(new Option());
				for (var i in dahdi_profiles) {
					var profile = dahdi_profiles[i];
					if (technology) {
						if (profile.technology == technology) {
							element.append(new Option(profile.name, profile.profile_id));
						}
					} else {
						if (profile.technology == "fxs" || profile.technology == "fxo") {
							element.append(new Option(profile.name, profile.profile_id));
						}
					}
				}
			});
			$("#dahdi_spansgeneral select[name='profiles[]']").each(function () {
				var element = $(this).empty();
				var profile_id = element.data("profile");
				if (technology) {
					for (var i in dahdi_profiles) {
						var profile = dahdi_profiles[i];
						if (profile.technology == technology) {
							element.append(new Option(profile.name, profile.profile_id));
							if (profile.profile_id == profile_id) { element.val(profile_id); }
						}
					}
				} else {
					var caps = $(this).data("caps").split(",");
					for (var i in dahdi_profiles) {
						var profile = dahdi_profiles[i];
						if (profile.technology == "fxs" || profile.technology == "fxo") {
							if ($.inArray(profile.signaling, caps) >= 0) {
								element.append(new Option(profile.name, profile.profile_id));
								if (profile.profile_id == profile_id) { element.val(profile_id); }
							}
						}
					}
				}
			});
			if (technology) {
				var framing_coding = dahdi_framing_coding[technology];
				$("#dahdi_spansgeneral select[name^='framing']").each(function () {
					var element = $(this).empty();
					for (var value in framing_coding.framing) {
						element.append(new Option(framing_coding.framing[value], value));
					}
					var current_framing = dahdi_current_params.framing;
					var current_technology = dahdi_current_params.technology;
					if (current_technology == technology && current_framing && current_framing.length > 0) {
						if (in_dropdown(current_framing, this)) {
							element.val(current_framing);
						}
					}
				});
				$("#dahdi_spansgeneral select[name^='coding']").each(function () {
					var element = $(this).empty();
					for (var value in framing_coding.coding) {
						element.append(new Option(framing_coding.coding[value], value));
					}
					var current_coding = dahdi_current_params.coding;
					var current_technology = dahdi_current_params.technology;

					if (current_technology == technology && current_coding && current_coding.length > 0) {
						if (in_dropdown(current_coding, this)) {
							element.val(current_coding);
						}
					}
				});
				$("#dahdi_spansgeneral input[name='crc4']").closest(".form-group").each(function () {
					if (technology == "e1pri" || technology == "e1r2") {
						var current_technology = dahdi_current_params.technology;
						var enabled = (current_technology == technology) ?
							dahdi_current_params.crc4 : dahdi_framing_coding[technology].crc4;
						$(this).find("input").prop("checked", enabled);
						// thx bootstrap...
						if (enabled) {
							$(this).find(".toggle").addClass("btn-success").removeClass("off btn-default");
						} else {
							$(this).find(".toggle").addClass("off btn-default").removeClass("btn-success");
						}
						$(this).show();
					} else {
						$(this).hide();
					}
				});
			}
		};
		var rebuild = function () {
			var technology = $("#dahdi_spansgeneral select[name='technology']").val();
			var elements = $("#dahdi_spansgeneral select[name='profiles[]']").closest(".form-group");
			elements.slice(1).remove();
			var element = elements.first();
			var dchans = { "e1pri": 15, "e1r2": 15, "t1pri": 24, "t1cas": 99 };
			var channels = { "e1pri": 31, "e1r2": 31, "t1pri": 23, "t1cas": 24 };
			var channo = parseInt(element.find("label").html().match(/\d+$/)[0]);
			var columns = element.closest(".row").children(".column-pbx");
			for (var i = 1, count = channels[technology]; i < count; ++i) {
				if (i == dchans[technology]) { continue; }
				var copy = element.clone();
				var label = copy.find("label");
				label.html(label.html().replace(/\d+/, channo + i));
				var colindex = Math.floor(i / (count / 2));
				$(columns[colindex]).append(copy);
			}
		}
		$("#dahdi_spansgeneral select[name='technology']").val(dahdi_current_params.technology);
		$("#dahdi_spansgeneral select[name^='technology']").change(function () { rebuild(); populate(); });
		populate();
	});
})();
