(function() {
	if($("#phonebook_form #mode").val() == "edit") {
		$("#phonebookgeneral").on("update_phonebook #phonebook-contact", function () {
			showReloadButton();
			data_table_phonebook_contact();
		});
		$("#phonebookgeneral .create-contact").click(function () {
			var key = $("#phonebookgeneral #phonebook-contact").data("id");
			pbx_request("phonebook", "create_contact", "add", key);
		});

		function data_table_phonebook_contact() {
			var DataTablesOptionsPhonebookContact = {
				"processing": true,
				"serverSide": true,
				"lengthMenu": [5, 10, 20, 50, 100],
				"pageLength": 5,
				"destroy": true,
				"ajax": {
					"url": "/",
					"type": "POST",
					"data": function (d) {
						d.class = "phonebook";
						d.method = "get_contacts";
						d.mode = "edit";
						d.data = $("#phonebookgeneral #phonebook-contact").data("id")
					}
				},
				"columns": [
					{"data": "first_name", "name": "First Name"},
					{"data": "last_name", "name": "Last Name"},
					{"data": "phone", "name": "phone"},
					{"data": "alt_phone", "name": "Additional phone"},
					{"data": "mobile", "name": "Mobile"},
					{"data": "organization", "name": "Organization"},
					{"data": "job_title", "name": "Job Title"},
					{"data": "email", "name": "Email"},
					{"data": "fax", "name": "Fax"},
					{"data": "action", "width": "65px", 'orderable': false},
				],
				order: [[0, 'asc']]
			};

			Ombutel.find("#phonebook-contact").DataTable(DataTablesOptionsPhonebookContact);
		}
		data_table_phonebook_contact();

		brands = $("#phonebookgeneral select#brands");
		sort_by = $("#phonebookgeneral select#sort_by");
		order_by = $("#phonebookgeneral select#order_by");
		sort_by.on("change", function () {
			update_export_url($(this).val(), order_by.val());
			generate_phonebook_link(brands.val(), $(this).val(), order_by.val());
		});
		order_by.on("change", function () {
			update_export_url(sort_by.val(), $(this).val());
			generate_phonebook_link(brands.val(), sort_by.val(), $(this).val());
		});
		brands.on("change", function () {
			if ($(this).val().length > 0) {
				generate_phonebook_link($(this).val(), sort_by.val(), order_by.val());
			} else {
				$("#phonebookgeneral input#phonebook_link").val('');
			}
		});

		function update_export_url(sort_by, order_by) {
			$("#phonebookgeneral .export_phonebook a").each(function () {
				export_url = $(this).attr("href").split("sort_by");
				$(this).attr("href", export_url[0] + "sort_by=" + sort_by + "&order_by=" + order_by);
			})
		}

		function generate_phonebook_link(brand, sort_by, order_by) {
			if (brand.length > 0) {
				$.ajax({
					type: "POST",
					dataType: "json",
					data: {
						class: "phonebook",
						method: "get_phonebooklink",
						brand: brand,
						order_by: order_by,
						sort_by: sort_by,
						phonebook_id: $("#phonebookgeneral #phonebook_id").val()
					},
					success: function (response) {
						if (response && response.link) {
							response.link = window.location.protocol + "//" + window.location.host + response.link;
							$("#phonebookgeneral input#phonebook_link").val(response.link);
						} else {
							$("#phonebookgeneral input#phonebook_link").val(phonebook_error);
							show_error();
						}
					},
					error: function () {
						$("#phonebookgeneral input#phonebook_link").val(phonebook_error);
						show_error();
					}
				});
			}
		}

		$("#phonebookgeneral .phonebook_link").on("click", function () {
			var link_field = $("#phonebookgeneral #phonebook_link");
			if (link_field.val().length > 0) {
				link_field.select();
				try {
					var result = document.execCommand("Copy");
					if (result) {
						link_field.attr("data-original-title", phonebook_copied).tooltip("show");
					}
				} catch (err) {
					console.log("unable to copy phonebook link");
				}
				link_field.removeAttr("data-original-title");
			}
		});
	}

	$("#phonebookgeneral button.generate_all").on("click", function() {
		pbx_request("phonebook", "build_all", "build");
	});

	function show_error() {
		// Why not use the standard notification mechanism?
		toastr.warning(
			phonebook_error_msg,
			phonebook_error,
			{
				"positionClass": "toast-top-center"
			}
		);
	}
})();
